summaryrefslogtreecommitdiffstats
path: root/source/l/glib/glib.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'source/l/glib/glib.SlackBuild')
-rwxr-xr-xsource/l/glib/glib.SlackBuild58
1 files changed, 47 insertions, 11 deletions
diff --git a/source/l/glib/glib.SlackBuild b/source/l/glib/glib.SlackBuild
index 62afbdfd9..afefe9e4c 100755
--- a/source/l/glib/glib.SlackBuild
+++ b/source/l/glib/glib.SlackBuild
@@ -1,6 +1,6 @@
-#!/bin/sh
+#!/bin/bash
-# Copyright 2006, 2007, 2008, 2009, 2010 Patrick J. Volkerding, Sebeka, MN, USA
+# Copyright 2006, 2007, 2008, 2009, 2010, 2018 Patrick J. Volkerding, Sebeka, MN, USA
# All rights reserved.
#
# Redistribution and use of this script, with or without modification, is
@@ -20,29 +20,37 @@
# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+cd $(dirname $0) ; CWD=$(pwd)
PKGNAM=glib
VERSION=${VERSION:-$(echo $PKGNAM-*.tar.?z* | rev | cut -f 3- -d . | cut -f 1 -d - | rev)}
-BUILD=${BUILD:-3}
+BUILD=${BUILD:-6}
# Automatically determine the architecture we're building on:
if [ -z "$ARCH" ]; then
case "$( uname -m )" in
- i?86) export ARCH=i486 ;;
+ i?86) export ARCH=i586 ;;
arm*) export ARCH=arm ;;
# Unless $ARCH is already set, use uname -m for all other archs:
*) export ARCH=$( uname -m ) ;;
esac
fi
-CWD=$(pwd)
+# If the variable PRINT_PACKAGE_NAME is set, then this script will report what
+# the name of the created package would be, and then exit. This information
+# could be useful to other scripts.
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PKGNAM-$VERSION-$ARCH-$BUILD.txz"
+ exit 0
+fi
+
TMP=${TMP:-/tmp}
PKG=$TMP/package-${PKGNAM}
rm -rf $PKG
mkdir -p $TMP $PKG
-if [ "$ARCH" = "i486" ]; then
- SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
LIBDIRSUFFIX=""
elif [ "$ARCH" = "s390" ]; then
SLKCFLAGS="-O2"
@@ -58,9 +66,20 @@ fi
cd $TMP
rm -rf ${PKGNAM}-${VERSION}
tar xvf $CWD/${PKGNAM}-$VERSION.tar.?z* || exit 1
-cd ${PKGNAM}-$VERSION
+cd ${PKGNAM}-$VERSION || exit 1
-bzcat $CWD/glib1.2_1.2.10-17.diff.bz2 | patch -p1 --verbose || exit 1
+zcat $CWD/glib-1.2.10-isowarning.patch.gz | patch -p1 --verbose || exit 1
+zcat $CWD/glib-1.2.10-gcc34.patch.gz | patch -p1 --verbose || exit 1
+zcat $CWD/glib-1.2.10-underquoted.patch.gz | patch -p1 --verbose || exit 1
+zcat $CWD/glib-1.2.10-no_undefined.patch.gz | patch -p1 --verbose || exit 1
+zcat $CWD/glib-1.2.10-multilib.patch.gz | patch -p1 --verbose || exit 1
+zcat $CWD/glib-1.2.10-unused-dep.patch.gz | patch -p1 --verbose || exit 1
+zcat $CWD/glib-1.2.10-autotools.patch.gz | patch -p0 --verbose || exit 1
+zcat $CWD/glib-1.2.10-format.patch.gz | patch -p0 --verbose || exit 1
+zcat $CWD/glib-1.2.10-gcc5.patch.gz | patch -p0 --verbose || exit 1
+
+# The original config.{guess,sub} do not work on x86_64 and some other $ARCH:
+cp -p /usr/share/libtool/build-aux/config.{guess,sub} .
# Make sure ownerships and permissions are sane:
chown -R root:root .
@@ -76,21 +95,38 @@ CFLAGS="$SLKCFLAGS" \
--prefix=/usr \
--libdir=/usr/lib${LIBDIRSUFFIX} \
--sysconfdir=/etc \
+ --disable-static \
--mandir=/usr/man \
--program-prefix= \
--program-suffix= \
- --build=$ARCH-slackware-linux
+ --build=$ARCH-slackware-linux || exit 1
# Build and install:
-make -j4 CFLAGS="$SLKCFLAGS" || exit 1
+make -j4 CFLAGS="$SLKCFLAGS" LIBTOOL=/usr/bin/libtool || exit 1
make CFLAGS="$SLKCFLAGS" install DESTDIR=$PKG || exit 1
+# Don't ship .la files:
+rm -f $PKG/{,usr/}lib${LIBDIRSUFFIX}/*.la
+
+# Throw away the static libraries that shouldn't have been built:
+rm -f $PKG/usr/lib${LIBDIRSUFFIX}/*.a
+
+# Make sure shared libraries are executable:
+chmod 755 $PKG/usr/lib${LIBDIRSUFFIX}/lib*.so.*
+
# Strip binaries:
( cd $PKG
find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
)
+# Remove rpaths:
+for file in $(find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF | cut -f 1 -d : 2> /dev/null) ; do
+ if [ ! "$(patchelf --print-rpath $file 2> /dev/null)" = "" ]; then
+ patchelf --remove-rpath $file
+ fi
+done
+
# Compress and link manpages, if any:
if [ -d $PKG/usr/man ]; then
( cd $PKG/usr/man